diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
index 6f64a7b56..33b7a21cd 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
@@ -13,20 +13,20 @@ import net.minecraft.client.gui.options.data.OptionsPageRegistry;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.render.Scissor;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
-
-import static org.lwjgl.opengl.GL11.*;
 
 public class ScreenOptions
-    extends Screen
-{
+    extends Screen {
     private static final int TOP_SPACING = 24;
     private static final int BUTTON_SPACING = 4;
     private static final int SEPARATOR_WIDTH = 8;
@@ -40,7 +40,7 @@ public class ScreenOptions
 
     private float optionsScrollAmount = 0.0f;
     private float pagesListScrollAmount = 0.0f;
-    private int top, bottom, optionsScrollRegionHeight, pagesListScrollRegionHeight, pageWidth, pagesListWidth;
+    public int top, bottom, optionsScrollRegionHeight, pagesListScrollRegionHeight, pageWidth, pagesListWidth;
 
     private Float oldOptionsScrollAmount;
     private Float oldPagesListScrollAmount;
@@ -50,39 +50,36 @@ public class ScreenOptions
     private int clickedComponentY;
     private ItemElement renderItem = null;
 
-    private boolean doOptionsScroll = true;
-    private boolean doPagesListScroll = true;
+    private final boolean doOptionsScroll = true;
+    private final boolean doPagesListScroll = true;
 
     private @Nullable TooltipElement tooltip = null;
 
-    public ScreenOptions(Screen parent)
-    {
+    public ScreenOptions(Screen parent) {
         this(parent, OptionsPages.GENERAL);
     }
 
-    public ScreenOptions(Screen parent, OptionsPage selectedPage)
-    {
+    public ScreenOptions(Screen parent, OptionsPage selectedPage) {
         super(parent);
         this.selectedPage = selectedPage;
         queueReload = false;
     }
 
     @Override
-    public void init()
-    {
+    public void init() {
         super.init();
 
-        buttons.add(new ButtonElement(0, width / 2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.options.button.done")));
+        this.buttons.add(new ButtonElement(0, this.width / 2 - 100, this.height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.options.button.done")));
 
-        top = TOP_SPACING;
-        bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
+        this.top = TOP_SPACING;
+        this.bottom = this.height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
 
-        optionsScrollRegionHeight = bottom - top;
-        pagesListScrollRegionHeight = bottom - top;
+        this.optionsScrollRegionHeight = this.bottom - this.top;
+        this.pagesListScrollRegionHeight = this.bottom - this.top;
 
-        this.renderItem = new ItemElement(mc);
+        this.renderItem = new ItemElement(this.mc);
 
-        this.selectedPage.initComponents(mc);
+        this.selectedPage.initComponents(this.mc);
 
         this.tooltip = new TooltipElement(this.mc);
     }
@@ -102,47 +99,43 @@ public class ScreenOptions
             return;
         }
 
-        if (eventKey == Keyboard.KEY_ESCAPE)
-        {
-            mc.texturePackList.refreshIfReady(); // Sets the texturepacks on menu close
+        if (eventKey == Keyboard.KEY_ESCAPE) {
+            this.mc.texturePackList.refreshIfReady(); // Sets the texturepacks on menu close
             reloadIfReady();
-            mc.displayScreen(getParentScreen());
-        }
-        else
-        {
-            for (OptionsComponent component : selectedPage.getComponents())
-            {
+            this.mc.displayScreen(getParentScreen());
+        } else {
+            for (OptionsComponent component : this.selectedPage.getComponents()) {
                 component.onKeyPress(eventKey, eventCharacter);
             }
         }
     }
 
-    private void drawPageItems(int x, int y, int width, int mouseX, int mouseY)
-    {
+    private void drawPageItems(int x, int y, int width, int mouseX, int mouseY) {
         int y2 = y;
-        for (OptionsComponent component : selectedPage.getComponents())
-        {
-            component.render(x, y2, width, mouseX - x, mouseY - y2);
+        for (OptionsComponent component : this.selectedPage.getComponents()) {
+            if (y2 + component.getHeight() >= this.top && y2 <= this.bottom) {
+                component.render(this, x, y2, width, mouseX - x, mouseY - y2);
+            }
             y2 += component.getHeight();
         }
     }
 
     private void drawPagesListItems(int x, int y, int width, int mouseX, int mouseY) {
         int y2 = y;
-        for(OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
+        for (OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
             if (!page.isVisible(this.mc)) {
                 continue;
             }
 
             String translated = I18n.getInstance().translateKey(page.getTranslationKey());
             int textColor = 0xFF7F7F7F;
-            if (page == selectedPage) {
+            if (page == this.selectedPage) {
                 textColor = 0xFFFFFFFF;
             }
             if (mouseX >= x && mouseX < x + width && mouseY >= y2 && mouseY < y2 + PAGE_BUTTON_HEIGHT) {
                 textColor = 0xFFFFFFA0;
             }
-            renderItem.render(page.getIcon(), x, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9);
+            this.renderItem.render(page.getIcon(), x, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9);
             drawStringShadow(this.fontRenderer, translated, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
             y2 += PAGE_BUTTON_HEIGHT;
         }
@@ -150,8 +143,7 @@ public class ScreenOptions
 
     @Override
     public void tick() {
-        for (OptionsComponent component : selectedPage.getComponents())
-        {
+        for (OptionsComponent component : this.selectedPage.getComponents()) {
             component.tick();
         }
     }
@@ -160,56 +152,57 @@ public class ScreenOptions
     protected void buttonClicked(@NotNull ButtonElement button) {
         super.buttonClicked(button);
 
-        if (button.id == 0)
-        {
-            mc.displayScreen(getParentScreen());
-            mc.texturePackList.refreshIfReady(); // Sets the texturepacks on menu close
+        if (button.id == 0) {
+            this.mc.displayScreen(getParentScreen());
+            this.mc.texturePackList.refreshIfReady(); // Sets the texturepacks on menu close
             reloadIfReady();
         }
     }
 
     @Override
     public void removed() {
-        for (OptionsComponent component : selectedPage.getComponents()) {
+        for (OptionsComponent component : this.selectedPage.getComponents()) {
             component.onClose();
         }
         super.removed();
-        mc.gameSettings.saveOptions();
-        mc.texturePackList.refreshIfReady();
+        this.mc.gameSettings.saveOptions();
+        this.mc.texturePackList.refreshIfReady();
         reloadIfReady();
     }
 
     private void scrollOptions(float amount) {
-        if(amount == 0.0f) return;
+        if (amount == 0.0f) return;
 
-        optionsScrollAmount += amount;
+        this.optionsScrollAmount += amount;
         onScrollOptions();
     }
 
     private void onScrollOptions() {
         int totalPageHeight = getTotalPageHeight();
-        if (optionsScrollAmount < 0 || optionsScrollRegionHeight > totalPageHeight) optionsScrollAmount = 0;
-        else if (optionsScrollAmount > totalPageHeight - optionsScrollRegionHeight) optionsScrollAmount = totalPageHeight - optionsScrollRegionHeight;
+        if (this.optionsScrollAmount < 0 || this.optionsScrollRegionHeight > totalPageHeight)
+            this.optionsScrollAmount = 0;
+        else if (this.optionsScrollAmount > totalPageHeight - this.optionsScrollRegionHeight)
+            this.optionsScrollAmount = totalPageHeight - this.optionsScrollRegionHeight;
     }
 
     private void scrollPagesList(float amount) {
-        if(amount == 0.0f) return;
+        if (amount == 0.0f) return;
 
-        pagesListScrollAmount += amount;
+        this.pagesListScrollAmount += amount;
         onScrollPagesList();
     }
 
     private void onScrollPagesList() {
         int totalPagesListHeight = getTotalPagesListHeight();
-        if (pagesListScrollAmount < 0 || pagesListScrollRegionHeight > totalPagesListHeight) pagesListScrollAmount = 0;
-        else if (pagesListScrollAmount > totalPagesListHeight - pagesListScrollRegionHeight) pagesListScrollAmount = totalPagesListHeight - pagesListScrollRegionHeight;
+        if (this.pagesListScrollAmount < 0 || this.pagesListScrollRegionHeight > totalPagesListHeight)
+            this.pagesListScrollAmount = 0;
+        else if (this.pagesListScrollAmount > totalPagesListHeight - this.pagesListScrollRegionHeight)
+            this.pagesListScrollAmount = totalPagesListHeight - this.pagesListScrollRegionHeight;
     }
 
-    private int getTotalPageHeight()
-    {
+    private int getTotalPageHeight() {
         int totalPageHeight = 0;
-        for (OptionsComponent component : selectedPage.getComponents())
-        {
+        for (OptionsComponent component : this.selectedPage.getComponents()) {
             totalPageHeight += component.getHeight();
         }
         return totalPageHeight;
@@ -217,7 +210,7 @@ public class ScreenOptions
 
     private int getTotalPagesListHeight() {
         int acc = 0;
-        for(OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
+        for (OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
             if (!page.isVisible(this.mc)) {
                 continue;
             }
@@ -228,19 +221,18 @@ public class ScreenOptions
     }
 
     @Override
-    public void render(int mx, int my, float renderPartialTicks)
-    {
+    public void render(int mx, int my, float renderPartialTicks) {
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
             mx = -1;
             my = -1;
-        } else if (doOptionsScroll && mx > pagesListWidth + SEPARATOR_WIDTH + PADDING && mx < width) {
+        } else if (this.doOptionsScroll && mx > this.pagesListWidth + SEPARATOR_WIDTH + PADDING && mx < this.width) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollOptions(Mouse.getDWheel() / -0.01f);
             } else {
                 scrollOptions(Mouse.getDWheel() / -0.05f);
             }
             onScrollOptions();
-        } else if (doPagesListScroll && mx >= 0 && mx <= pagesListWidth) {
+        } else if (this.doPagesListScroll && mx >= 0 && mx <= this.pagesListWidth) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollPagesList(Mouse.getDWheel() / -0.01f);
             } else {
@@ -249,86 +241,86 @@ public class ScreenOptions
             onScrollPagesList();
         }
 
-        if (pickingKeyBinding == null && pickingKeyBindingComponent == null && mc.controllerInput != null) {
-            final int xc = (int) mc.controllerInput.cursorX;
-            if (doOptionsScroll && xc > pagesListWidth + SEPARATOR_WIDTH + PADDING && xc < width) {
-                scrollOptions(mc.controllerInput.joyRight.getY() / 0.2f);
+        if (pickingKeyBinding == null && pickingKeyBindingComponent == null && this.mc.controllerInput != null) {
+            final int xc = (int) this.mc.controllerInput.cursorX;
+            if (this.doOptionsScroll && xc > this.pagesListWidth + SEPARATOR_WIDTH + PADDING && xc < this.width) {
+                scrollOptions(this.mc.controllerInput.joyRight.getY() / 0.2f);
                 onScrollOptions();
-            } else if (doPagesListScroll && xc >= 0 && xc <= pagesListWidth) {
-                scrollPagesList(mc.controllerInput.joyRight.getY() / 0.2f);
+            } else if (this.doPagesListScroll && xc >= 0 && xc <= this.pagesListWidth) {
+                scrollPagesList(this.mc.controllerInput.joyRight.getY() / 0.2f);
                 onScrollPagesList();
             }
         }
 
-        pagesListWidth = (int)(width * 0.25f);
-        pageWidth = width - (pagesListWidth + SEPARATOR_WIDTH + (PADDING * 2));
+        this.pagesListWidth = (int) (this.width * 0.25f);
+        this.pageWidth = this.width - (this.pagesListWidth + SEPARATOR_WIDTH + (PADDING * 2));
         I18n i18n = I18n.getInstance();
 
         renderBackground();
-        overlayBackground(0, width, 0, top);
-        overlayBackground(0, width, bottom, height);
+        overlayBackground(0, this.width, 0, this.top);
+        overlayBackground(0, this.width, this.bottom, this.height);
 
-        Scissor.enable(0, top, width, bottom - top);
-        if (my >= top && my <= bottom) {
-            drawPageItems(pagesListWidth + SEPARATOR_WIDTH + PADDING, top - (int) optionsScrollAmount, pageWidth - 8, mx, my);
+        Scissor.enable(0, this.top, this.width, this.bottom - this.top);
+        if (my >= this.top && my <= this.bottom) {
+            drawPageItems(this.pagesListWidth + SEPARATOR_WIDTH + PADDING, this.top - (int) this.optionsScrollAmount, this.pageWidth - 8, mx, my);
         } else {
-            drawPageItems(pagesListWidth + SEPARATOR_WIDTH + PADDING, top - (int) optionsScrollAmount, pageWidth - 8, -1, -1);
+            drawPageItems(this.pagesListWidth + SEPARATOR_WIDTH + PADDING, this.top - (int) this.optionsScrollAmount, this.pageWidth - 8, -1, -1);
         }
         Scissor.disable();
 
-        Scissor.enable(0, top, pagesListWidth, bottom - top);
+        Scissor.enable(0, this.top, this.pagesListWidth, this.bottom - this.top);
         int pagesListHeight = getTotalPagesListHeight();
-        int pagesListY = top - (int) pagesListScrollAmount;
-        if (pagesListHeight < bottom - top) {
-            pagesListY = top + (bottom - top - pagesListHeight) / 2;
+        int pagesListY = this.top - (int) this.pagesListScrollAmount;
+        if (pagesListHeight < this.bottom - this.top) {
+            pagesListY = this.top + (this.bottom - this.top - pagesListHeight) / 2;
         }
-        if (my >= top && my <= bottom) {
-            drawPagesListItems(PADDING - 4, pagesListY, pagesListWidth - PADDING, mx, my);
+        if (my >= this.top && my <= this.bottom) {
+            drawPagesListItems(PADDING - 4, pagesListY, this.pagesListWidth - PADDING, mx, my);
         } else {
-            drawPagesListItems(PADDING - 4, pagesListY, pagesListWidth - PADDING, -1, -1);
+            drawPagesListItems(PADDING - 4, pagesListY, this.pagesListWidth - PADDING, -1, -1);
         }
         Scissor.disable();
 
         // Draw shadows
-        if (mc.currentWorld == null)
-        {
-            Tessellator tessellator = Tessellator.instance;
-            GL11.glDisable(GL_DEPTH_TEST);
-            int shadowSize = 4;
-            GL11.glEnable(GL_BLEND);
-            GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-            GL11.glDisable(GL_ALPHA_TEST);
-            GL11.glShadeModel(GL_SMOOTH);
-            GL11.glDisable(GL_TEXTURE_2D);
+        if (this.mc.currentWorld == null) {
 
+            int shadowSize = 4;
+//            GL11.glDisable(GL_ALPHA_TEST);
+//            GL11.glShadeModel(GL_SMOOTH);
+
+            GLRenderer.pushFrame();
+            GLRenderer.setShader(Shaders.COLOR);
+            GLRenderer.enableState(State.DEPTH_TEST);
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            TessellatorGeneral tessellator = GLRenderer.getTessellator();
             tessellator.startDrawingQuads();
-            tessellator.setColorRGBA_I(0, 0);
-            tessellator.addVertexWithUV(0, top + shadowSize, 0.0D, 0.0D, 1.0D);
-            tessellator.addVertexWithUV(width, top + shadowSize, 0.0D, 1.0D, 1.0D);
-            tessellator.setColorRGBA_I(0, 255);
-            tessellator.addVertexWithUV(width, top, 0.0D, 1.0D, 0.0D);
-            tessellator.addVertexWithUV(0, top, 0.0D, 0.0D, 0.0D);
+            tessellator.setColor2i(0, 0);
+            tessellator.addVertexWithUV(0, this.top + shadowSize, 0.0D, 0.0D, 1.0D);
+            tessellator.addVertexWithUV(this.width, this.top + shadowSize, 0.0D, 1.0D, 1.0D);
+            tessellator.setColor2i(0, 255);
+            tessellator.addVertexWithUV(this.width, this.top, 0.0D, 1.0D, 0.0D);
+            tessellator.addVertexWithUV(0, this.top, 0.0D, 0.0D, 0.0D);
             tessellator.draw();
 
             tessellator.startDrawingQuads();
-            tessellator.setColorRGBA_I(0, 255);
-            tessellator.addVertexWithUV(0, bottom, 0.0D, 0.0D, 1.0D);
-            tessellator.addVertexWithUV(width, bottom, 0.0D, 1.0D, 1.0D);
-            tessellator.setColorRGBA_I(0, 0);
-            tessellator.addVertexWithUV(width, bottom - shadowSize, 0.0D, 1.0D, 0.0D);
-            tessellator.addVertexWithUV(0, bottom - shadowSize, 0.0D, 0.0D, 0.0D);
+            tessellator.setColor2i(0, 255);
+            tessellator.addVertexWithUV(0, this.bottom, 0.0D, 0.0D, 1.0D);
+            tessellator.addVertexWithUV(this.width, this.bottom, 0.0D, 1.0D, 1.0D);
+            tessellator.setColor2i(0, 0);
+            tessellator.addVertexWithUV(this.width, this.bottom - shadowSize, 0.0D, 1.0D, 0.0D);
+            tessellator.addVertexWithUV(0, this.bottom - shadowSize, 0.0D, 0.0D, 0.0D);
             tessellator.draw();
 
-            GL11.glEnable(GL_TEXTURE_2D);
-            GL11.glShadeModel(GL_FLAT);
-            GL11.glEnable(GL_ALPHA_TEST);
-            GL11.glDisable(GL_BLEND);
+            GLRenderer.popFrame();
+//            GL11.glShadeModel(GL_FLAT);
+//            GL11.glEnable(GL_ALPHA_TEST);
         }
 
-        overlayBackground(pagesListWidth, pagesListWidth + SEPARATOR_WIDTH, top, bottom);
+        overlayBackground(this.pagesListWidth, this.pagesListWidth + SEPARATOR_WIDTH, this.top, this.bottom);
 
         String titleLanguageKey = "gui.options.title";
-        drawStringCenteredShadow(fontRenderer, i18n.translateKey(titleLanguageKey), width / 2, 5, 0xffffff);
+        drawStringCenteredShadow(this.fontRenderer, i18n.translateKey(titleLanguageKey), this.width / 2, 5, 0xffffff);
 
         drawOptionsScrollBar(mx, my);
         drawPagesListScrollBar(mx, my);
@@ -337,7 +329,7 @@ public class ScreenOptions
 
         if (this.tooltip != null) {
             @Nullable String tooltipTranslationKey = null;
-            for (OptionsComponent component : selectedPage.getComponents()) {
+            for (OptionsComponent component : this.selectedPage.getComponents()) {
                 @Nullable String componentTooltip = component.getTooltipTranslationKey();
                 if (componentTooltip != null) {
                     tooltipTranslationKey = componentTooltip;
@@ -351,104 +343,99 @@ public class ScreenOptions
         }
 
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
-            drawRect(0, 0, width, height, 0xA0000000);
-            drawStringCenteredNoShadow(fontRenderer, i18n.translateKeyAndFormat("gui.options.label.picking_keybinding", i18n.translateKey(pickingKeyBinding.getId())), width / 2, height / 2 - 4, 0xffffff);
+            drawRect(0, 0, this.width, this.height, 0xA0000000);
+            drawStringCenteredNoShadow(this.fontRenderer, i18n.translateKeyAndFormat("gui.options.label.picking_keybinding", i18n.translateKey(pickingKeyBinding.getId())), this.width / 2, this.height / 2 - 4, 0xffffff);
         }
     }
 
     protected void drawOptionsScrollBar(int mouseX, int mouseY) {
         float totalPageHeight = getTotalPageHeight();
-        float scrollBarHeightPercent = optionsScrollRegionHeight / totalPageHeight;
+        float scrollBarHeightPercent = this.optionsScrollRegionHeight / totalPageHeight;
 
-        if(scrollBarHeightPercent > 1.0f) return;
+        if (scrollBarHeightPercent > 1.0f) return;
 
-        glDisable(GL_TEXTURE_2D);
+        int scrollBarX = this.width - 6;
 
-        int scrollBarX = width - 6;
-
-        int scrollBarHeightPx = (int) (scrollBarHeightPercent * optionsScrollRegionHeight);
-        if(scrollBarHeightPx < 32) {
+        int scrollBarHeightPx = (int) (scrollBarHeightPercent * this.optionsScrollRegionHeight);
+        if (scrollBarHeightPx < 32) {
             scrollBarHeightPx = 32;
         }
 
-        float scrollPercent = optionsScrollAmount / (totalPageHeight - optionsScrollRegionHeight);
-
-        int scrollBarY = (int) (top + (optionsScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
+        float scrollPercent = this.optionsScrollAmount / (totalPageHeight - this.optionsScrollRegionHeight);
 
-        Tessellator t = Tessellator.instance;
+        int scrollBarY = (int) (this.top + (this.optionsScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
 
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        TessellatorGeneral t = GLRenderer.getTessellator();
         t.startDrawingQuads();
-        t.setColorOpaque(0, 0, 0);
-        t.drawRectangle(scrollBarX, top, 6, optionsScrollRegionHeight);
-        t.setColorRGBA_I(0x808080, 255);
+        t.setColorOpaque3i(0, 0, 0);
+        t.drawRectangle(scrollBarX, this.top, 6, this.optionsScrollRegionHeight);
+        t.setColor2i(0x808080, 255);
         t.drawRectangle(scrollBarX, scrollBarY, 6, scrollBarHeightPx);
-        t.setColorRGBA_I(0xc0c0c0, 255);
+        t.setColor2i(0xc0c0c0, 255);
         t.drawRectangle(scrollBarX + 1, scrollBarY, 5, scrollBarHeightPx - 1);
         t.draw();
+        GLRenderer.popFrame();
 
-        glEnable(GL_TEXTURE_2D);
-
-        if(clickX != null && clickY != null) {
-            if(clickX >= scrollBarX && clickY >= top && clickX <= scrollBarX + 6 && clickY < bottom) {
-                if(oldOptionsScrollAmount == null) {
-                    oldOptionsScrollAmount = optionsScrollAmount;
+        if (this.clickX != null && this.clickY != null) {
+            if (this.clickX >= scrollBarX && this.clickY >= this.top && this.clickX <= scrollBarX + 6 && this.clickY < this.bottom) {
+                if (this.oldOptionsScrollAmount == null) {
+                    this.oldOptionsScrollAmount = this.optionsScrollAmount;
                 }
-                optionsScrollAmount = oldOptionsScrollAmount + (clickY - mouseY) * (1.0f / scrollBarHeightPercent) * -1.0f;
+                this.optionsScrollAmount = this.oldOptionsScrollAmount + (this.clickY - mouseY) * (1.0f / scrollBarHeightPercent) * -1.0f;
                 onScrollOptions();
             }
-        }else {
-            oldOptionsScrollAmount = null;
+        } else {
+            this.oldOptionsScrollAmount = null;
         }
     }
 
     protected void drawPagesListScrollBar(int mouseX, int mouseY) {
         float totalPagesListHeight = getTotalPagesListHeight();
-        float scrollBarHeightPercent = pagesListScrollRegionHeight / totalPagesListHeight;
+        float scrollBarHeightPercent = this.pagesListScrollRegionHeight / totalPagesListHeight;
 
-        if(scrollBarHeightPercent > 1.0f) return;
+        if (scrollBarHeightPercent > 1.0f) return;
 
-        glDisable(GL_TEXTURE_2D);
+        int scrollBarX = this.pagesListWidth - 6;
 
-        int scrollBarX = pagesListWidth - 6;
-
-        int scrollBarHeightPx = (int) (scrollBarHeightPercent * pagesListScrollRegionHeight);
-        if(scrollBarHeightPx < 32) {
+        int scrollBarHeightPx = (int) (scrollBarHeightPercent * this.pagesListScrollRegionHeight);
+        if (scrollBarHeightPx < 32) {
             scrollBarHeightPx = 32;
         }
 
-        float scrollPercent = pagesListScrollAmount / (totalPagesListHeight - pagesListScrollRegionHeight);
-
-        int scrollBarY = (int) (top + (pagesListScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
+        float scrollPercent = this.pagesListScrollAmount / (totalPagesListHeight - this.pagesListScrollRegionHeight);
 
-        Tessellator t = Tessellator.instance;
+        int scrollBarY = (int) (this.top + (this.pagesListScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
 
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        TessellatorGeneral t = GLRenderer.getTessellator();
         t.startDrawingQuads();
-        t.setColorOpaque(0, 0, 0);
-        t.drawRectangle(scrollBarX, top, 6, pagesListScrollRegionHeight);
-        t.setColorRGBA_I(0x808080, 255);
+        t.setColorOpaque3i(0, 0, 0);
+        t.drawRectangle(scrollBarX, this.top, 6, this.pagesListScrollRegionHeight);
+        t.setColor2i(0x808080, 255);
         t.drawRectangle(scrollBarX, scrollBarY, 6, scrollBarHeightPx);
-        t.setColorRGBA_I(0xc0c0c0, 255);
+        t.setColor2i(0xc0c0c0, 255);
         t.drawRectangle(scrollBarX + 1, scrollBarY, 5, scrollBarHeightPx - 1);
         t.draw();
+        GLRenderer.popFrame();
 
-        glEnable(GL_TEXTURE_2D);
-
-        if(clickX != null && clickY != null) {
-            if(clickX >= scrollBarX && clickY >= top && clickX <= scrollBarX + 6 && clickY < bottom) {
-                if(oldPagesListScrollAmount == null) {
-                    oldPagesListScrollAmount = pagesListScrollAmount;
+        if (this.clickX != null && this.clickY != null) {
+            if (this.clickX >= scrollBarX && this.clickY >= this.top && this.clickX <= scrollBarX + 6 && this.clickY < this.bottom) {
+                if (this.oldPagesListScrollAmount == null) {
+                    this.oldPagesListScrollAmount = this.pagesListScrollAmount;
                 }
-                pagesListScrollAmount = oldPagesListScrollAmount + (clickY - mouseY) * (1.0f / scrollBarHeightPercent) * -1.0f;
+                this.pagesListScrollAmount = this.oldPagesListScrollAmount + (this.clickY - mouseY) * (1.0f / scrollBarHeightPercent) * -1.0f;
                 onScrollOptions();
             }
-        }else {
-            oldPagesListScrollAmount = null;
+        } else {
+            this.oldPagesListScrollAmount = null;
         }
     }
 
     @Override
-    public void mouseClicked(int mx, int my, int buttonNum)
-    {
+    public void mouseClicked(int mx, int my, int buttonNum) {
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
             pickingKeyBinding.bind(InputDevice.mouse, buttonNum);
             pickingKeyBindingComponent.update();
@@ -459,40 +446,39 @@ public class ScreenOptions
 
         super.mouseClicked(mx, my, buttonNum);
 
-        int left = pagesListWidth + SEPARATOR_WIDTH + PADDING;
+        int left = this.pagesListWidth + SEPARATOR_WIDTH + PADDING;
 
-        if (mx >= pagesListWidth + SEPARATOR_WIDTH && my >= top && my <= bottom) {
-            int componentY = top - (int) optionsScrollAmount;
-            for (OptionsComponent component : selectedPage.getComponents())
-            {
-                if (mx >= left && mx <= left + pageWidth - PADDING && my >= componentY && my <= componentY + component.getHeight()) {
-                    component.onMouseClick(buttonNum, left, componentY, pageWidth - PADDING, mx - left, my - componentY);
-                    clickedComponent = component;
-                    clickedComponentY = componentY;
+        if (mx >= this.pagesListWidth + SEPARATOR_WIDTH && my >= this.top && my <= this.bottom) {
+            int componentY = this.top - (int) this.optionsScrollAmount;
+            for (OptionsComponent component : this.selectedPage.getComponents()) {
+                if (mx >= left && mx <= left + this.pageWidth - PADDING && my >= componentY && my <= componentY + component.getHeight()) {
+                    component.onMouseClick(buttonNum, left, componentY, this.pageWidth - PADDING, mx - left, my - componentY);
+                    this.clickedComponent = component;
+                    this.clickedComponentY = componentY;
                     break;
                 }
                 componentY += component.getHeight();
             }
-        } else if (mx >= 0 && mx <= pagesListWidth && my >= top && my <= bottom) {
+        } else if (mx >= 0 && mx <= this.pagesListWidth && my >= this.top && my <= this.bottom) {
             int pagesListHeight = getTotalPagesListHeight();
-            int pagesListY = top - (int) pagesListScrollAmount;
-            if (pagesListHeight < bottom - top) {
-                pagesListY = top + (bottom - top - pagesListHeight) / 2;
+            int pagesListY = this.top - (int) this.pagesListScrollAmount;
+            if (pagesListHeight < this.bottom - this.top) {
+                pagesListY = this.top + (this.bottom - this.top - pagesListHeight) / 2;
             }
-            for(OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
+            for (OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
                 if (!page.isVisible(this.mc)) {
                     continue;
                 }
 
-                if (mx >= 0 && mx <= pagesListWidth && my >= pagesListY && my <= pagesListY + PAGE_BUTTON_HEIGHT) {
-                    for (OptionsComponent component : selectedPage.getComponents()) {
+                if (mx >= 0 && mx <= this.pagesListWidth && my >= pagesListY && my <= pagesListY + PAGE_BUTTON_HEIGHT) {
+                    for (OptionsComponent component : this.selectedPage.getComponents()) {
                         component.onClose();
                     }
-                    optionsScrollAmount = 0;
-                    selectedPage = page;
-                    this.selectedPage.initComponents(mc);
-                    mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
-                    mc.texturePackList.refreshIfReady();
+                    this.optionsScrollAmount = 0;
+                    this.selectedPage = page;
+                    this.selectedPage.initComponents(this.mc);
+                    this.mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+                    this.mc.texturePackList.refreshIfReady();
                     reloadIfReady();
                     break;
                 }
@@ -500,8 +486,8 @@ public class ScreenOptions
             }
         }
 
-        clickX = mx;
-        clickY = my;
+        this.clickX = mx;
+        this.clickY = my;
     }
 
     @Override
